# Data Extraction and charting from  NSE Stock Exchange
# www.Tricks12345.com
from selenium import webdriver
import time
from selenium.webdriver.common.action_chains import ActionChains
from flask import Flask, render_template,request
import tkinter
from tkinter import messagebox
from matplotlib import pyplot as plt
tk = tkinter.Tk()
tk.withdraw()
app = Flask(__name__)
driver = webdriver.Chrome()
driver.maximize_window()
totalrows = []
headerdata = []; bodydata = []; rowsdata = []
url = 'https://www.nseindia.com'
driver.get(url)
time.sleep(3)
menu = driver.find_element_by_css_selector('#main_livemkt')
submenu =  driver.find_element_by_css_selector('#main_livemkt #main_livewth_stkwth')
ActionChains(driver).move_to_element(menu).click(submenu).perform()
time.sleep(3)
driver.current_window_handle          
totalrows = driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr')
rowcount = len(driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr'))        
for row in  totalrows:
             rowdata = []
             for c,col in enumerate(row.find_elements_by_tag_name('td') or row.find_elements_by_tag_name('th')):
                if c  == 1 or c  == 2 or c  == 13 or c  == 15:
                        continue
                if col.tag_name  == 'th': headerdata.append(col.text)
                if col.tag_name  == 'td': rowdata.append(col.text)
             bodydata.append(tuple(rowdata))
rowsdata = bodydata[2:]
colscount = len(headerdata)
driver.close()
time.sleep(2)
messagebox.showinfo('Confirmation', 'Pavan now run the app')
print(rowsdata)

@app.route('/') 
def index():
     return render_template('index.html')
#####Entire Table##########################    
@app.route('/EntireTable')
def  EntireTable():                 
         return render_template('NSE_Equity_Table_Data.html', headerdata = headerdata, totalrows = rowsdata, rowscount = len(rowsdata), colscount =colscount)

#####First 5 Rows##########################    
    
@app.route('/FirstFiveRows')
def  FirstFiveRows():
         TopFive = rowsdata[:6]          
         return render_template('FirstFiveRows.html', headerdata = headerdata, totalrows = TopFive, rowscount = 5, colscount =colscount)

#####Bottom 5 Rows##########################  
@app.route('/BottomFiveRows')
def  BottomFiveRows():
         bottomFive = rowsdata[-5:]          
         return render_template('BottomFiveRows.html', headerdata = headerdata, totalrows = bottomFive, rowscount = 5, colscount =colscount)

#####retrieve the data where symbol length is greater than 5###### 
@app.route('/SymbolLengthGreaterthanFive')
def  SymbolLengthGreaterthanFive():
    r = []
    for i in range(len(rowsdata)):
        if  len(rowsdata[i][0]) >=6:
           r.append(rowsdata[i])
           #print(str(i) +  '= '  + rowsdata[i][0])
           #variablename|length
           #{% if totalrows[i][0]|length >= 6 %}
    return render_template('SymbolLengthGreaterthanFive.html', headerdata = headerdata, totalrows = r, rowscount = len(r), colscount =colscount)        

#####Open Price Greater than 1000########################## 
@app.route('/OpenPriceGreaterThanThousand')
def  OpenPriceGreaterThanThousand():
    r = []
    for e in range(len(rowsdata)):
        q = rowsdata[e][1]
        z = q.replace(',','')
        openprice = float(z)
        if openprice >= 1000:
            r.append(rowsdata[e])            
    return render_template('OpenPriceGreaterThanThousand.html', headerdata = headerdata, totalrows = r, rowscount = len(r), colscount =colscount)

@app.route('/SortDescBasedOn52wHigh')
def  SortDescBasedOn52wHigh():
    # Sort the table data based on 52w High column in descending order
    t = [] 
    for e in range(len(rowsdata)): 
            q = rowsdata[e][9].replace(',','')
            openprice = float(q)
            t.append((openprice, e))  
    t.sort(reverse = True)
    r = []
    for i in range(len(t)):
         q = t[i][1]
         r.append(rowsdata[q]) 
    return render_template('SortDescBasedOnFiftytwoHigh.html', headerdata = headerdata, totalrows = r, rowscount = len(r), colscount =colscount)

@app.route('/SortDescBasedOnFiftyTwowL')
def  SortDescBasedOnFiftyTwowL():
    # Sort the table data based on 52w Low column in Ascending  order
    t = [] 
    for e in range(len(rowsdata)): 
            q = rowsdata[e][10].replace(',','')
            openprice = float(q)
            t.append((openprice, e))  
    t.sort()
    r = []
    for i in range(len(t)):
         q = t[i][1]
         r.append(rowsdata[q]) 
    return render_template('SortDescBasedOnFiftytwoHigh.html', headerdata = headerdata, totalrows = r, rowscount = len(r), colscount =colscount)

#########################Top five companies based on LTP and charting

@app.route('/TopFiveCompaniesBasedOnLTP')
def  TopFiveCompaniesBasedOnLTP():
    # Top Five companies based on LTP
    t = [] 
    for e in range(len(rowsdata)): 
            q = rowsdata[e][4].replace(',','')
            openprice = float(q)
            t.append((openprice, e))  
    t.sort(reverse = True)
    r = []
    companyList = []
    yaxisdata = []
    for i in range(5):
         q = t[i][1]
         r.append(rowsdata[q])
         companyList.append(rowsdata[q][0])
         yaxisdata.append(t[i][0])
    plt.bar(companyList, yaxisdata, color = 'r', label =  'LTP')            
    plt.title('Top 5 Companies based on LTP')
    plt.legend()
    plt.savefig('./static/TopFiveCompaniesBasedonLTP.png')
    #plt.show()                                        
    return render_template('TopFiveCompaniesBasedOnLTP.html', headerdata = headerdata, totalrows = r, rowscount = len(r), colscount =colscount)
app.run(host = 'localhost', port = 5000)



